// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cstdio>
//#include <stdlib.h>
#include "pingu.hh"
#include "colmap.hh"

//CL_Surface* Pingu::sprite = 0;
CL_Surface* Pingu::fall_sprite = 0; 
ColMap*     Pingu::colmap = 0;
PinguMap*   Pingu::map = 0;
CL_Surface* Pingu::walker;

Pingu::Pingu(int x, int y)
{
  //cout << "Pingu.set_pos init" << endl;
  //  if (!data_loaded) {
  //  load_data(resource);
  //}

  alive = true;
  falling = 0;
  direction = left;
  walker_pos = 0;
  set_pos(x, y);
  falling = 0;
  //id = "New Set_Pos"; 
}

Pingu::Pingu()
{
  //  cout << "Pingu init" << endl;

  alive = true;
  falling = 0;
  direction = left;
  walker_pos = 0;

  /*  if (sprite == 0 || fall_sprite == 0) {
    //fprintf(stderr, "Sceo\n");
    exit(1);
    }*/
  //  cout << "Pingu init ende" << endl;
  //id = "Normal";
}

Pingu::~Pingu()
{
}

void
Pingu::get_surface()
{
  
}

void
Pingu::restore_surface()
{
  
}

void
Pingu::draw(int x, int y)
{
  //  restore_surface();
  //  get_surface();

  map->mark_dirty(x,y,32,32);
  
  if (falling > 2) {
    // cout << "Falling" << endl;

    if (fall_sprite) {
      // !!!!!! wired  !!!!!!!!!!!
      fall_sprite->put_screen(x, y);
      fall_sprite->put_screen(x, y);
    } else {
      cout << "aeuaoeuaoeuaoeuoae" << endl;
      exit(EXIT_FAILURE);
    }
  } else {
    walker->put_screen(x,y,walker_pos 
    			 + ((direction == -1) ? 0 : 3 )
			 );
    // wired
    walker->put_screen(x,y,walker_pos 
    			 + ((direction == -1) ? 0 : 3 )
			 );

    if (walker_pos > 2)
      walker_pos = 0;
    /*
    if (direction == left) {
      walker[walker_pos++]->put_screen(x, y);
      
      if (walker_pos > 2)
	 walker_pos = 0;
     } else {
       walker_r[walker_pos++]->put_screen(x, y);
      
       if (walker_pos > 2)
	walker_pos = 0;
	}*/
  }
}

void
Pingu::draw()
{
  if (!alive)
    return;

  draw(x_pos-16, y_pos-32);
  //  cout << "f: Putting Pingu" << endl;

  if (falling > 2) {
    //draw_sprite(scr, fall_sprite, x_pos - sprite->w/2, y_pos-sprite->h);
  } else {
    if (direction == left) {
      // draw_sprite
	//	(scr, sprite, x_pos - sprite->w /2 ,  y_pos- sprite->h);
    } else {
      //draw_sprite_h_flip
      //	(scr, sprite, x_pos - sprite->w /2 ,  y_pos- sprite->h);
    }
  }
}

void 
Pingu::set_pos(int x, int y)
{
  x_pos = x;
  y_pos = y;
}

void change(int& dir)
{
  if (dir == left)
    dir = right;
  else
    dir =left;
}

int
Pingu::rel_getpixel(/*BITMAP* col_map,*/ int x, int y)
{
  if (colmap == 0) {
    cout << "Colmap nicht benutzt" << endl;
    exit(EXIT_FAILURE);
  }
  /*
  return getpixel(col_map,
		  x_pos + (x * direction),
		  y_pos + y);
  */
  int return_value;

  return_value = colmap->getpixel(x_pos + (x * direction), (y_pos) - y);

  //if (return_value != 0)
    //    cout << "Solid" << endl;
    
  //cout << return_value;

  return return_value;
    //  return 1;
}


void
Pingu::let_move(void/*BITMAP* col_map*/)
{
  if (!alive) {
    //cout << "One dead Pingu" << endl;
    return;
  }

  /*  
  if (x_pos > 799)
    direction = left;

  if (x_pos < 0)
    direction = right;
  */

  //  x_pos += direction;
  //y_pos += rand()%3 -1;

  if (rel_getpixel(0, -1) == 0) {
    // Pingu is falling
    ++y_pos;
    ++falling;
    //cout <<  "Falling" << endl;
    
  } else {
    if (falling > 100) {
      alive = false;
      return;
  }
  
    falling = 0;
    // Pingu is walking
    if (rel_getpixel(1, 0) == 0) {
      x_pos += direction;    
    } else {
      if (rel_getpixel(1,1)== 0) {
	x_pos += direction;
	y_pos--;
      } else if (rel_getpixel(1,2)== 0) {
	x_pos += direction;
	y_pos -= 2;
      } else {
	change(direction);
      }
      /*      if (rel_getpixel(1, -1) == 0) {
	--y_pos;
	x_pos += direction;
      } else if (rel_getpixel(1, -2) == 0) {
	y_pos -= 2;
	x_pos += direction;
      } else if (rel_getpixel(1,1) == 0) {
	++y_pos;
	x_pos += direction;*/
    }
  }
}

bool
Pingu::is_alive(void)
{
  return alive;
}

void
Pingu::set_colmap(ColMap* a)
{
  cout << "Colmap gesetzt: " << a << endl;
  colmap = a;
}

void
Pingu::set_map(PinguMap* m)
{
  map = m;
}

void
Pingu::load_data(CL_ResourceManager* resource)
{
  cout << "Loading Pingu Data..." << endl;

  walker = CL_Res_Surface::load("Game/walker", *resource);
  //  sprite = CL_Res_Surface::load("Game/sprite", *resource);
  fall_sprite = CL_Res_Surface::load("Game/stopper", *resource);

  //  data_loaded = true;
}

/* EOF */
