// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include "pingutilemap.hh"

PinguTileMap::PinguTileMap(PLF* data, CL_ResourceManager* resource)
{
  tile_provider = new PinguTileProvider(resource);
  map.resize(19);
  for(int i=0; i < map.size(); ++i) {
    map[i].resize(25);
  }
  load(data->get_fg());
}

PinguTileMap::~PinguTileMap()
{
}

void
PinguTileMap::mark_dirty(int x, int y, int w, int h)
{
  
}

int
PinguTileMap::load(const char* filename)
{
  ifstream in(filename);

  if (!in) {
    perror(filename);
    exit(EXIT_FAILURE);
  }

  char temp[255];

  for(int y=0; y < map.size(); ++y) {
    for(int x=0; x < map[y].size(); ++x) {
      in >> temp;
      map[y][x].load(atoi(temp), tile_provider);
      //      cout << map[y][x].i() << " ";
    }
    //    cout << endl;
  }
  
  //  return PinguTileMap::load(&in);
  return 0;
}

int
PinguTileMap::load(ifstream* in)
{
  int w,h;

  (*in) >> w >> h;

  map.resize(h);
  
  for(int i=0; i < map.size(); ++i)
    map[i].resize(i);
}

void
PinguTileMap::put_screen(int x, int y)
{
  PinguTileMap::draw();
}

/*
ColMap
PinguTileMap::get_colmap()
{
}*/

void
PinguTileMap::draw()
{
  for(int y=0; y < map.size(); ++y) {
    for(int x=0; x < map[y].size(); ++x) {
      map[y][x].draw(x*32,y*32);
    }
  }
}

void
PinguTileMap::start_anim()
{
}

void
PinguTileMap::stop_anim()
{
}

/* EOF */
